function IMLogger(aTimeStamp, aContactId) {
  this.fileName = aContactId + " " + aTimeStamp + ".log";
  this.foStream = null;
}

IMLogger.prototype.closeLogFile = function() {
  this.foStream.close();
}

IMLogger.prototype.log = function(aTimeStamp, aContactId, aMsgText) {
  var line = "[" + aTimeStamp + "] <" + aContactId + "> " + aMsgText + "\r\n";
  var utf8Line = Utils.convertUTF16ToUTF8Bytes(line);
  window.fileStream.write(utf8Line, utf8Line.length);
}

IMLogger.prototype.openLogFile = function() {
  var success = false;
  var file = Utils.getExtensionSubDirectory("logs");
  file.append(this.fileName);
  this.foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
  try {
    this.foStream.init(file, 0x02 | 0x08 | 0x10, 0664, 0);
    success = true;
  }
  catch (aException) {}
  return success;
}