var MessageStyle = {
  fn : Utils.getPref("getCharPref", "font.name", "Arial"),
  co : Utils.getPref("getCharPref", "font.color", "#000000"),
  efB : Utils.getPref("getBoolPref", "font.bold", false),
  efI : Utils.getPref("getBoolPref", "font.italic", false),
  efU : Utils.getPref("getBoolPref", "font.underline", false),
  efS : Utils.getPref("getBoolPref", "font.strike", false),
  myMms : "",
  myStyle : "",
  controller: null
};

MessageStyle.onStyleChanged = function() {
  var mms = "FN=" + encodeURIComponent(this.fn) + "; EF=";
  if (this.efB) {
    mms += "B";
  }
  if (this.efI) {
    mms += "I";
  }
  if (this.efU) {
    mms += "U";
  }
  if (this.efS) {
    mms += "S";
  }
  var bgr = swapRedBlue(this.co.substr(1, 6));
  mms += "; CO=" + bgr + "; CS=0; PF=00";
  this.myMms = mms;
  this.myStyle = this.getStyleFromMms(mms);
  this.controller.onMessageStyleChanged();
}

MessageStyle.getStyleFromMms = function(aMms) {
  var params = {};
  var fields = aMms.split("; ");
  var fontName = "";
  var fontFamily = "";
  var style = "";
  for (field in fields) {
    var param = fields[field].split("=");
    params[param[0].toUpperCase()] = param[1];
  }
  if ("FN" in params) {
    fontName = "'" + decodeURIComponent(params["FN"]) + "'";
  }
  if ("EF" in params) {
    for (i in params["EF"]) {
      switch (params["EF"].indexOf(i)) {
        case "B":
          style += "font-weight: bold; ";
          break;
        case "I":
          style += "font-style: italic; ";
          break;
        case "U":
          style += "text-decoration: underline; ";
          break;
        case "S":
          style += "text-decoration: line-through; ";
          break;
      }
    }
  }
  if ("CO" in params) {
    var bgr = "000000".substr(0, 6 - params["CO"].length) + params["CO"];
    style += "color: #" + swapRedBlue(bgr) + "; ";
  }
  if ("PF" in params) {
    switch (params["PF"].substr(0, 1)) {
      case "1":
        fontFamily = "serif";
        break;
      case "2":
        fontFamily = "sans-serif";
        break;
      case "3":
        fontFamily = "monospace";
        break;
      case "4":
        fontFamily = "cursive";
        break;
      case "5":
        fontFamily = "fantasy";
        break;
    }
  }
  if ("RL" in params && params["RL"] == "1") {
    style += "text-align: right; ";
  }
  if (fontName && fontFamily) {
    style += "font-family: " + fontName + ", " + fontFamily + "; ";
  }
  else {
    if (fontName || fontFamily) {
      style += "font-family: " + fontName + fontFamily + "; ";
    }
  }
  return style;
}

function swapRedBlue(aColor) {
  return aColor.substr(4, 2) + aColor.substr(2, 2) + aColor.substr(0, 2)
}